# Enum Class AttributeMapper.AttributeStability

java.lang.Object
java.lang.Enum<AttributeMapper.AttributeStability>
java.lang.classfile.AttributeMapper.AttributeStability

All Implemented Interfaces:
  `Serializable`, `Comparable<AttributeMapper.AttributeStability>`, `Constable`

Enclosing interface:
  `AttributeMapper<A extends Attribute<A>>`

public static enum AttributeMapper.AttributeStability extends Enum<AttributeMapper.AttributeStability>
Indicates the data dependency of the `class` file representation of an attribute. Whether an attribute can be bulk-copied by its binary representation to a new `class` file depends on if its data refers to other parts of its enclosing `class` file.

API Note:
  This dependency is called "stability" because it indicates the conditions for a `class` file attribute to be eligible for bulk-copying to another `class` file.
Since:
  24
See Also:
  - `AttributeMapper.stability()`

## Nested Class Summary

### Nested classes/interfaces declared in class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`CP_REFS`
In addition to standalone data, the attribute refers to the constant pool, including the `BootstrapMethods` attribute, of its enclosing `class` file.
`LABELS`
In addition to standalone data and references to the constant pool, the attribute refers to positions into the `code` array of a `Code` attribute.
`STATELESS`
The attribute contains only standalone data, and has no reference to other parts of its enclosing `class` file, besides the name of the attribute.
`UNKNOWN`
The attribute is completely unknown.
`UNSTABLE`
The attribute refers to structures not managed by the library (type variable lists, etc.).

## Method Summary

Modifier and Type
Method
Description
`static AttributeMapper.AttributeStability`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static AttributeMapper.AttributeStability[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods declared in class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods declared in class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### STATELESS

public static final AttributeMapper.AttributeStability STATELESS
The attribute contains only standalone data, and has no reference to other parts of its enclosing `class` file, besides the name of the attribute. Thus, its contents can always be bulk-copied to another `class` file.

For example, a bit mask is standalone data.

### CP_REFS

public static final AttributeMapper.AttributeStability CP_REFS
In addition to standalone data, the attribute refers to the constant pool, including the `BootstrapMethods` attribute, of its enclosing `class` file. Thus, it can be bulk-copied when the destination `class` file extends its constant pool from that of the original `class`. It must be expanded to translate constant pool references and rewritten when constant pool indices are not compatible.

For example, a `Utf8Entry` is a reference to the constant pool.

See Also:
  - `ConstantPoolBuilder.of(ClassModel)`
  - `ClassFile.ConstantPoolSharingOption`

### LABELS

public static final AttributeMapper.AttributeStability LABELS
In addition to standalone data and references to the constant pool, the attribute refers to positions into the `code` array of a `Code` attribute. Thus, it can be bulked-copied when the `code` array is unchanged, which requires that the destination `class` file extends its constant pool from that of the original `class`. It must be expanded to translate `Label`s or constant pool references and rewritten if the `code` array is perturbed, including when constant pool indices are not compatible.

For example, a bci value, modeled by a `Label`, is a reference to a position in the `code` array.

### UNSTABLE

public static final AttributeMapper.AttributeStability UNSTABLE
The attribute refers to structures not managed by the library (type variable lists, etc.). As a result, even when the attribute is expanded, those references may not be correctly translated, and the rewritten results may be incorrect.

If the attribute is read from a `class` file, `ClassFile.AttributesProcessingOption` determines whether to preserve or drop the attribute during transformation.

See Also:
  - `ClassFile.AttributesProcessingOption.DROP_UNSTABLE_ATTRIBUTES`

### UNKNOWN

public static final AttributeMapper.AttributeStability UNKNOWN
The attribute is completely unknown. As a result, expanding and rewriting is not possible, and any difference between the destination `class` file and its enclosing `class` file may make the attribute incorrect.

`ClassFile.AttributesProcessingOption` determines whether to preserve or drop the attribute during transformation.

See Also:
  - `UnknownAttribute`
  - `ClassFile.AttributesProcessingOption.DROP_UNSTABLE_ATTRIBUTES`
  - `ClassFile.AttributesProcessingOption.DROP_UNKNOWN_ATTRIBUTES`

## Method Details

### values

public static AttributeMapper.AttributeStability[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static AttributeMapper.AttributeStability valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null